/* MainWindow.c generated by valac 0.39.5, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
* Copyright (c) 2017 Daniel Foré (http://danielfore.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	GSettings* settings;
	GdkRGBA gdk_color;
	GtkEntry* bg_entry;
	GtkEntry* fg_entry;
	GtkLabel* results_label;
	GradeLabel* aa_level;
	GradeLabel* aaa_level;
};


static gpointer main_window_parent_class = NULL;

GType main_window_get_type (void) G_GNUC_CONST;
GType grade_label_get_type (void) G_GNUC_CONST;
#define MAIN_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAIN_WINDOW, MainWindowPrivate))
#define MAIN_WINDOW_RESULTS_CSS "\n" \
"        @define-color colorForeground %s;\n" \
"        @define-color colorBackground %s;\n" \
"\n" \
"        .output-header,\n" \
"        .results {\n" \
"            transition: all 250ms ease-in-out;\n" \
"        }\n" \
"    "
MainWindow* main_window_new (GtkApplication* application);
MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_on_entry_icon_press (MainWindow* self,
                                      GtkEntry* entry);
static void main_window_on_entry_changed (MainWindow* self);
static void main_window_style_results_pane (MainWindow* self,
                                     const gchar* fg_color,
                                     const gchar* bg_color);
static gdouble main_window_get_luminance (MainWindow* self,
                                   GdkRGBA* color);
void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static gdouble main_window_sanitize_color (MainWindow* self,
                                    gdouble color);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
GradeLabel* grade_label_new (const gchar* level);
GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
static void _main_window___lambda4_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEventButton* event);
static void __main_window___lambda4__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void _main_window___lambda5_ (MainWindow* self);
static void __main_window___lambda5__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda6_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEventButton* event);
static void __main_window___lambda6__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void _main_window___lambda7_ (MainWindow* self);
static void __main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void main_window_finalize (GObject * obj);


MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MainWindow*) g_object_new (object_type, "application", application, "height-request", 500, "icon-name", "com.github.danrabbit.harvey", "resizable", FALSE, "title", _ ("Harvey"), "width-request", 700, NULL);
	return self;
}


MainWindow*
main_window_new (GtkApplication* application)
{
	return main_window_construct (TYPE_MAIN_WINDOW, application);
}


static void
main_window_on_entry_icon_press (MainWindow* self,
                                 GtkEntry* entry)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkColorSelectionDialog* dialog = NULL;
	GtkColorSelectionDialog* _tmp2_;
	GtkColorSelectionDialog* _tmp3_;
	GtkColorSelectionDialog* _tmp4_;
	GtkColorSelection* widget = NULL;
	GtkColorSelectionDialog* _tmp5_;
	GtkColorSelection* _tmp6_;
	GtkColorSelection* _tmp7_;
	GdkRGBA _tmp8_;
	GtkColorSelectionDialog* _tmp9_;
	GtkColorSelectionDialog* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = gtk_entry_get_text (entry);
	_tmp1_ = _tmp0_;
	gdk_rgba_parse (&self->priv->gdk_color, _tmp1_);
	_tmp2_ = (GtkColorSelectionDialog*) gtk_color_selection_dialog_new ("");
	g_object_ref_sink (_tmp2_);
	dialog = _tmp2_;
	_tmp3_ = dialog;
	gtk_window_set_deletable ((GtkWindow*) _tmp3_, FALSE);
	_tmp4_ = dialog;
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, (GtkWindow*) self);
	_tmp5_ = dialog;
	_tmp6_ = gtk_color_selection_dialog_get_color_selection (_tmp5_);
	widget = _tmp6_;
	_tmp7_ = widget;
	_tmp8_ = self->priv->gdk_color;
	gtk_color_selection_set_current_rgba (_tmp7_, &_tmp8_);
	_tmp9_ = dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp9_) == ((gint) GTK_RESPONSE_OK)) {
		GtkColorSelection* _tmp10_;
		GdkRGBA _tmp11_ = {0};
		GdkRGBA _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp10_ = widget;
		gtk_color_selection_get_current_rgba (_tmp10_, &_tmp11_);
		_tmp12_ = _tmp11_;
		_tmp13_ = gdk_rgba_to_string (&_tmp12_);
		_tmp14_ = _tmp13_;
		gtk_entry_set_text (entry, _tmp14_);
		_g_free0 (_tmp14_);
	}
	_tmp15_ = dialog;
	g_signal_emit_by_name ((GtkDialog*) _tmp15_, "close");
	_g_object_unref0 (dialog);
}


static void
main_window_on_entry_changed (MainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->fg_entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ > 2) {
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp6_ = self->priv->bg_entry;
		_tmp7_ = gtk_entry_get_text (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp10_ > 2;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp11_ = self->priv->fg_entry;
		_tmp12_ = gtk_entry_get_text (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = self->priv->bg_entry;
		_tmp15_ = gtk_entry_get_text (_tmp14_);
		_tmp16_ = _tmp15_;
		main_window_style_results_pane (self, _tmp13_, _tmp16_);
	}
}


static void
main_window_style_results_pane (MainWindow* self,
                                const gchar* fg_color,
                                const gchar* bg_color)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GSettings* _tmp9_;
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GSettings* _tmp13_;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gdouble pango_fg_luminance = 0.0;
	GdkRGBA _tmp17_;
	gdouble pango_bg_luminance = 0.0;
	GdkRGBA _tmp18_;
	gdouble contrast_ratio = 0.0;
	gdouble _tmp19_;
	gdouble _tmp20_;
	GtkLabel* _tmp25_;
	gdouble _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp32_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fg_color != NULL);
	g_return_if_fail (bg_color != NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	{
		gchar* colored_css = NULL;
		gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
		_tmp1_ = g_strdup_printf (MAIN_WINDOW_RESULTS_CSS, fg_color, bg_color);
		colored_css = _tmp1_;
		_tmp2_ = provider;
		_tmp3_ = colored_css;
		_tmp4_ = colored_css;
		_tmp5_ = strlen (_tmp4_);
		_tmp6_ = _tmp5_;
		gtk_css_provider_load_from_data (_tmp2_, _tmp3_, (gssize) _tmp6_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (colored_css);
			goto __catch0_g_error;
		}
		_tmp7_ = gdk_screen_get_default ();
		_tmp8_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_g_free0 (colored_css);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (provider);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp9_ = self->priv->settings;
	_tmp10_ = self->priv->fg_entry;
	_tmp11_ = gtk_entry_get_text (_tmp10_);
	_tmp12_ = _tmp11_;
	g_settings_set_string (_tmp9_, "fg-color", _tmp12_);
	_tmp13_ = self->priv->settings;
	_tmp14_ = self->priv->bg_entry;
	_tmp15_ = gtk_entry_get_text (_tmp14_);
	_tmp16_ = _tmp15_;
	g_settings_set_string (_tmp13_, "bg-color", _tmp16_);
	gdk_rgba_parse (&self->priv->gdk_color, fg_color);
	_tmp17_ = self->priv->gdk_color;
	pango_fg_luminance = main_window_get_luminance (self, &_tmp17_);
	gdk_rgba_parse (&self->priv->gdk_color, bg_color);
	_tmp18_ = self->priv->gdk_color;
	pango_bg_luminance = main_window_get_luminance (self, &_tmp18_);
	_tmp19_ = pango_bg_luminance;
	_tmp20_ = pango_fg_luminance;
	if (_tmp19_ > _tmp20_) {
		gdouble _tmp21_;
		gdouble _tmp22_;
		_tmp21_ = pango_bg_luminance;
		_tmp22_ = pango_fg_luminance;
		contrast_ratio = (_tmp21_ + 0.05) / (_tmp22_ + 0.05);
	} else {
		gdouble _tmp23_;
		gdouble _tmp24_;
		_tmp23_ = pango_fg_luminance;
		_tmp24_ = pango_bg_luminance;
		contrast_ratio = (_tmp23_ + 0.05) / (_tmp24_ + 0.05);
	}
	_tmp25_ = self->priv->results_label;
	_tmp26_ = contrast_ratio;
	_tmp27_ = g_strdup_printf ("%.1f:1", _tmp26_);
	_tmp28_ = _tmp27_;
	gtk_label_set_label (_tmp25_, _tmp28_);
	_g_free0 (_tmp28_);
	_tmp29_ = contrast_ratio;
	if (_tmp29_ >= 4.5) {
		GradeLabel* _tmp30_;
		_tmp30_ = self->priv->aa_level;
		grade_label_set_pass (_tmp30_, TRUE);
	} else {
		GradeLabel* _tmp31_;
		_tmp31_ = self->priv->aa_level;
		grade_label_set_pass (_tmp31_, FALSE);
	}
	_tmp32_ = contrast_ratio;
	if (_tmp32_ >= ((gdouble) 7)) {
		GradeLabel* _tmp33_;
		_tmp33_ = self->priv->aaa_level;
		grade_label_set_pass (_tmp33_, TRUE);
	} else {
		GradeLabel* _tmp34_;
		_tmp34_ = self->priv->aaa_level;
		grade_label_set_pass (_tmp34_, FALSE);
	}
	_g_object_unref0 (provider);
}


static gdouble
main_window_get_luminance (MainWindow* self,
                           GdkRGBA* color)
{
	gdouble result = 0.0;
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	gdouble green = 0.0;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	gdouble blue = 0.0;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (color != NULL, 0.0);
	_tmp0_ = *color;
	_tmp1_ = _tmp0_.red;
	red = main_window_sanitize_color (self, _tmp1_) * 0.2126;
	_tmp2_ = *color;
	_tmp3_ = _tmp2_.green;
	green = main_window_sanitize_color (self, _tmp3_) * 0.7152;
	_tmp4_ = *color;
	_tmp5_ = _tmp4_.blue;
	blue = main_window_sanitize_color (self, _tmp5_) * 0.0722;
	result = (red + green) + blue;
	return result;
}


static gdouble
main_window_sanitize_color (MainWindow* self,
                            gdouble color)
{
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	if (color <= 0.03928) {
		color = color / 12.92;
	} else {
		color = pow ((color + 0.055) / 1.055, 2.4);
	}
	result = color;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_main_window___lambda4_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEventButton* event)
{
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		GtkEntry* _tmp0_;
		_tmp0_ = self->priv->fg_entry;
		main_window_on_entry_icon_press (self, _tmp0_);
	}
}


static void
__main_window___lambda4__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEventButton* event,
                                               gpointer self)
{
	_main_window___lambda4_ ((MainWindow*) self, icon_pos, event);
}


static void
_main_window___lambda5_ (MainWindow* self)
{
	main_window_on_entry_changed (self);
}


static void
__main_window___lambda5__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda5_ ((MainWindow*) self);
}


static void
_main_window___lambda6_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEventButton* event)
{
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		GtkEntry* _tmp0_;
		_tmp0_ = self->priv->bg_entry;
		main_window_on_entry_icon_press (self, _tmp0_);
	}
}


static void
__main_window___lambda6__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEventButton* event,
                                               gpointer self)
{
	_main_window___lambda6_ ((MainWindow*) self, icon_pos, event);
}


static void
_main_window___lambda7_ (MainWindow* self)
{
	main_window_on_entry_changed (self);
}


static void
__main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda7_ ((MainWindow*) self);
}


static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GSettings* _tmp0_;
	GtkLabel* fg_label = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* bg_label = NULL;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GSettings* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GSettings* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
	GtkGrid* input_grid = NULL;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkEntry* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLabel* _tmp32_;
	GtkGrid* _tmp33_;
	GtkEntry* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkStyleContext* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GradeLabel* _tmp42_;
	GradeLabel* _tmp43_;
	GradeLabel* _tmp44_;
	GradeLabel* _tmp45_;
	GtkGrid* results_grid = NULL;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	GtkGrid* _tmp52_;
	GradeLabel* _tmp53_;
	GtkGrid* _tmp54_;
	GradeLabel* _tmp55_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkHeaderBar* input_header = NULL;
	GtkHeaderBar* _tmp61_;
	GtkHeaderBar* _tmp62_;
	GtkHeaderBar* _tmp63_;
	GtkStyleContext* input_header_context = NULL;
	GtkHeaderBar* _tmp64_;
	GtkStyleContext* _tmp65_;
	GtkStyleContext* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkStyleContext* _tmp69_;
	GtkStyleContext* _tmp70_;
	GtkHeaderBar* output_header = NULL;
	GtkHeaderBar* _tmp71_;
	GtkHeaderBar* _tmp72_;
	GtkStyleContext* output_header_context = NULL;
	GtkHeaderBar* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkStyleContext* _tmp75_;
	GtkStyleContext* _tmp76_;
	GtkStyleContext* _tmp77_;
	GtkStyleContext* _tmp78_;
	GtkStyleContext* _tmp79_;
	GtkGrid* header_grid = NULL;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkHeaderBar* _tmp82_;
	GtkGrid* _tmp83_;
	GtkHeaderBar* _tmp84_;
	GtkSizeGroup* sizegroup = NULL;
	GtkSizeGroup* _tmp85_;
	GtkSizeGroup* _tmp86_;
	GtkGrid* _tmp87_;
	GtkSizeGroup* _tmp88_;
	GtkHeaderBar* _tmp89_;
	GtkGrid* _tmp90_;
	GtkStyleContext* _tmp91_;
	GtkGrid* _tmp92_;
	GtkEntry* _tmp93_;
	GtkEntry* _tmp94_;
	GtkEntry* _tmp95_;
	GtkEntry* _tmp96_;
	GtkEntry* _tmp97_;
	const gchar* _tmp98_;
	const gchar* _tmp99_;
	GtkEntry* _tmp100_;
	const gchar* _tmp101_;
	const gchar* _tmp102_;
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_tmp0_ = g_settings_new ("com.github.danrabbit.harvey");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("Foreground Color"));
	g_object_ref_sink (_tmp1_);
	fg_label = _tmp1_;
	_tmp2_ = fg_label;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "h4");
	_tmp4_ = fg_label;
	gtk_label_set_xalign (_tmp4_, (gfloat) 0);
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Background Color"));
	g_object_ref_sink (_tmp5_);
	bg_label = _tmp5_;
	_tmp6_ = bg_label;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "h4");
	_tmp8_ = bg_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 12);
	_tmp9_ = bg_label;
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
	_tmp10_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->fg_entry);
	self->priv->fg_entry = _tmp10_;
	_tmp11_ = self->priv->fg_entry;
	_tmp12_ = self->priv->settings;
	_tmp13_ = g_settings_get_string (_tmp12_, "fg-color");
	_tmp14_ = _tmp13_;
	gtk_entry_set_text (_tmp11_, _tmp14_);
	_g_free0 (_tmp14_);
	_tmp15_ = self->priv->fg_entry;
	gtk_entry_set_placeholder_text (_tmp15_, "#333");
	_tmp16_ = self->priv->fg_entry;
	gtk_entry_set_icon_from_icon_name (_tmp16_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
	_tmp17_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->bg_entry);
	self->priv->bg_entry = _tmp17_;
	_tmp18_ = self->priv->bg_entry;
	_tmp19_ = self->priv->settings;
	_tmp20_ = g_settings_get_string (_tmp19_, "bg-color");
	_tmp21_ = _tmp20_;
	gtk_entry_set_text (_tmp18_, _tmp21_);
	_g_free0 (_tmp21_);
	_tmp22_ = self->priv->bg_entry;
	gtk_entry_set_placeholder_text (_tmp22_, "rgb (110, 200, 230)");
	_tmp23_ = self->priv->bg_entry;
	gtk_entry_set_icon_from_icon_name (_tmp23_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
	_tmp24_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp24_);
	input_grid = _tmp24_;
	_tmp25_ = input_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp25_, GTK_ORIENTATION_VERTICAL);
	_tmp26_ = input_grid;
	g_object_set ((GtkWidget*) _tmp26_, "margin", 12, NULL);
	_tmp27_ = input_grid;
	_tmp28_ = fg_label;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = input_grid;
	_tmp30_ = self->priv->fg_entry;
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = input_grid;
	_tmp32_ = bg_label;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = input_grid;
	_tmp34_ = self->priv->bg_entry;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = (GtkLabel*) gtk_label_new ("12:1");
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->results_label);
	self->priv->results_label = _tmp35_;
	_tmp36_ = self->priv->results_label;
	g_object_set ((GtkWidget*) _tmp36_, "expand", TRUE, NULL);
	_tmp37_ = self->priv->results_label;
	_tmp38_ = gtk_widget_get_style_context ((GtkWidget*) _tmp37_);
	gtk_style_context_add_class (_tmp38_, "h1");
	_tmp39_ = self->priv->results_label;
	gtk_label_set_selectable (_tmp39_, TRUE);
	_tmp40_ = self->priv->results_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp40_, GTK_ALIGN_CENTER);
	_tmp41_ = self->priv->results_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp41_, GTK_ALIGN_CENTER);
	_tmp42_ = grade_label_new ("WCAG AA");
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->aa_level);
	self->priv->aa_level = _tmp42_;
	_tmp43_ = self->priv->aa_level;
	gtk_widget_set_halign ((GtkWidget*) _tmp43_, GTK_ALIGN_CENTER);
	_tmp44_ = grade_label_new ("WCAG AAA");
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (self->priv->aaa_level);
	self->priv->aaa_level = _tmp44_;
	_tmp45_ = self->priv->aaa_level;
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
	_tmp46_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp46_);
	results_grid = _tmp46_;
	_tmp47_ = results_grid;
	gtk_grid_set_row_spacing (_tmp47_, 12);
	_tmp48_ = results_grid;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_add_class (_tmp49_, "results");
	_tmp50_ = results_grid;
	_tmp51_ = self->priv->results_label;
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 0, 0, 2, 1);
	_tmp52_ = results_grid;
	_tmp53_ = self->priv->aa_level;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 0, 1, 1, 1);
	_tmp54_ = results_grid;
	_tmp55_ = self->priv->aaa_level;
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 1, 1, 1, 1);
	_tmp56_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp56_);
	grid = _tmp56_;
	_tmp57_ = grid;
	_tmp58_ = input_grid;
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
	_tmp59_ = grid;
	_tmp60_ = results_grid;
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
	_tmp61_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp61_);
	input_header = _tmp61_;
	_tmp62_ = input_header;
	gtk_header_bar_set_decoration_layout (_tmp62_, "close:");
	_tmp63_ = input_header;
	gtk_header_bar_set_show_close_button (_tmp63_, TRUE);
	_tmp64_ = input_header;
	_tmp65_ = gtk_widget_get_style_context ((GtkWidget*) _tmp64_);
	_tmp66_ = _g_object_ref0 (_tmp65_);
	input_header_context = _tmp66_;
	_tmp67_ = input_header_context;
	gtk_style_context_add_class (_tmp67_, "input-header");
	_tmp68_ = input_header_context;
	gtk_style_context_add_class (_tmp68_, "titlebar");
	_tmp69_ = input_header_context;
	gtk_style_context_add_class (_tmp69_, "default-decoration");
	_tmp70_ = input_header_context;
	gtk_style_context_add_class (_tmp70_, GTK_STYLE_CLASS_FLAT);
	_tmp71_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp71_);
	output_header = _tmp71_;
	_tmp72_ = output_header;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp72_, TRUE);
	_tmp73_ = output_header;
	_tmp74_ = gtk_widget_get_style_context ((GtkWidget*) _tmp73_);
	_tmp75_ = _g_object_ref0 (_tmp74_);
	output_header_context = _tmp75_;
	_tmp76_ = output_header_context;
	gtk_style_context_add_class (_tmp76_, "output-header");
	_tmp77_ = output_header_context;
	gtk_style_context_add_class (_tmp77_, "titlebar");
	_tmp78_ = output_header_context;
	gtk_style_context_add_class (_tmp78_, "default-decoration");
	_tmp79_ = output_header_context;
	gtk_style_context_add_class (_tmp79_, GTK_STYLE_CLASS_FLAT);
	_tmp80_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp80_);
	header_grid = _tmp80_;
	_tmp81_ = header_grid;
	_tmp82_ = input_header;
	gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = header_grid;
	_tmp84_ = output_header;
	gtk_container_add ((GtkContainer*) _tmp83_, (GtkWidget*) _tmp84_);
	_tmp85_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	sizegroup = _tmp85_;
	_tmp86_ = sizegroup;
	_tmp87_ = input_grid;
	gtk_size_group_add_widget (_tmp86_, (GtkWidget*) _tmp87_);
	_tmp88_ = sizegroup;
	_tmp89_ = input_header;
	gtk_size_group_add_widget (_tmp88_, (GtkWidget*) _tmp89_);
	_tmp90_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp90_);
	_tmp91_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp91_, "rounded");
	_tmp92_ = header_grid;
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp92_);
	_tmp93_ = self->priv->fg_entry;
	g_signal_connect_object (_tmp93_, "icon-press", (GCallback) __main_window___lambda4__gtk_entry_icon_press, self, 0);
	_tmp94_ = self->priv->fg_entry;
	g_signal_connect_object ((GtkEditable*) _tmp94_, "changed", (GCallback) __main_window___lambda5__gtk_editable_changed, self, 0);
	_tmp95_ = self->priv->bg_entry;
	g_signal_connect_object (_tmp95_, "icon-press", (GCallback) __main_window___lambda6__gtk_entry_icon_press, self, 0);
	_tmp96_ = self->priv->bg_entry;
	g_signal_connect_object ((GtkEditable*) _tmp96_, "changed", (GCallback) __main_window___lambda7__gtk_editable_changed, self, 0);
	_tmp97_ = self->priv->fg_entry;
	_tmp98_ = gtk_entry_get_text (_tmp97_);
	_tmp99_ = _tmp98_;
	_tmp100_ = self->priv->bg_entry;
	_tmp101_ = gtk_entry_get_text (_tmp100_);
	_tmp102_ = _tmp101_;
	main_window_style_results_pane (self, _tmp99_, _tmp102_);
	_g_object_unref0 (sizegroup);
	_g_object_unref0 (header_grid);
	_g_object_unref0 (output_header_context);
	_g_object_unref0 (output_header);
	_g_object_unref0 (input_header_context);
	_g_object_unref0 (input_header);
	_g_object_unref0 (grid);
	_g_object_unref0 (results_grid);
	_g_object_unref0 (input_grid);
	_g_object_unref0 (bg_label);
	_g_object_unref0 (fg_label);
	return obj;
}


static void
main_window_class_init (MainWindowClass * klass)
{
	main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MainWindowPrivate));
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
}


static void
main_window_instance_init (MainWindow * self)
{
	self->priv = MAIN_WINDOW_GET_PRIVATE (self);
}


static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->bg_entry);
	_g_object_unref0 (self->priv->fg_entry);
	_g_object_unref0 (self->priv->results_label);
	_g_object_unref0 (self->priv->aa_level);
	_g_object_unref0 (self->priv->aaa_level);
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
}


GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
		GType main_window_type_id;
		main_window_type_id = g_type_register_static (gtk_window_get_type (), "MainWindow", &g_define_type_info, 0);
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}



